<?php 
/*
Plugin Name:  WP Marketplace
Plugin URI: http://wpeden.com/
Description: Marketplace Plugin for Wordpress
Author: Shaon
Version: 1.6.1
Author URI: http://shaon.info/
*/

 
include("libs/functions.php");
include("libs/class.plugin.php");
include("libs/class.order.php");
include("libs/class.payment.php");
include("libs/class.html.php");
include("libs/cart.php");
include("libs/print_invoice.php");
include("libs/hooks.php");


global $sap;

if(function_exists('get_option')){
if ( get_option('permalink_structure') != '' ) $sap = '?';
else $sap = "&";
}
session_start();

$wpmp_plugin = new ahm_plugin('wpmarketplace');

function wpmp_post_types(){   
    register_post_type("wpmarketplace",array(
            
            'labels' => array(
                'name' => __('Marketplace'),
                'singular_name' => __('Product'),
                'add_new' => __('Add Product'),
                'add_new_item' => __('Add New Product'),
                'edit_item' => __('Edit Product'), 
                'new_item' => __('New Product'),
                'view_item' => __('View Product'),
                'search_items' => __('Search Product'),
                'not_found' =>  __('No product found'),
                'not_found_in_trash' => __('No product found in Trash'), 
                'parent_item_colon' => ''
            ),
            'public' => true,
            'publicly_queryable' => true,
            'has_archive' => true,
            'show_ui' => true, 
            'query_var' => true,
            'rewrite' => array('slug'=>'product','with_front'=>true),
            'capability_type' => 'post',
            'hierarchical' => false,
            'menu_icon' =>plugins_url().'/wpmarketplace/images/wpmp.png',            
            'supports' => array('title','editor','author','excerpt','thumbnail','ptype','comments') ,
            'taxonomies' => array('ptype')
             
        )
    );     
    
    
    
}

function register_marketplace_product_taxonomies() 
{
  // Add new taxonomy, make it hierarchical (like categories)
  $labels = array(
    'name' => _x( 'Product Types', 'taxonomy general name' ),
    'singular_name' => _x( 'Type', 'taxonomy singular name' ),
    'search_items' =>  __( 'Search Types' ),
    'all_items' => __( 'All Types' ),
    'parent_item' => __( 'Parent Type' ),
    'parent_item_colon' => __( 'Parent Type:' ),
    'edit_item' => __( 'Edit Type' ), 
    'update_item' => __( 'Update Type' ),
    'add_new_item' => __( 'Add New Type' ),
    'new_item_name' => __( 'New Type Name' ),
    'menu_name' => __( 'Product Types' ),
  );     

  register_taxonomy('ptype',array('wpmarketplace'), array(
    'hierarchical' => true,
    'labels' => $labels,
    'show_ui' => true,
    'query_var' => true,
    'rewrite' => array( 'slug' => 'product-category' ),
  ));

   
}

function wpmp_install(){
    global $wpdb;
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');    
    $sql[] = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}mp_orders` (
  `order_id` varchar(100) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `date` int(11) DEFAULT NULL,
  `items` text,
  `cart_data` text,
  `total` double DEFAULT NULL,
  `order_status` enum('Pending','Processing','Completed','Canceled') DEFAULT NULL,
  `payment_status` enum('Pending','Processing','Completed','Canceled') DEFAULT NULL,
  `uid` int(11) DEFAULT NULL,
  `order_notes` varchar(255) DEFAULT NULL,
  `payment_method` varchar(255) DEFAULT NULL,
  `shipping_method` varchar(255) DEFAULT NULL,
  `shipping_cost` float DEFAULT NULL,
  `billing_shipping_data` text,
  `cart_discount` float DEFAULT NULL,
  PRIMARY KEY (`order_id`)
) ENGINE=MyISAM";
    
    $sql[] = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}mp_order_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `oid` varchar(255) NOT NULL,
  `pid` int(11) NOT NULL,
  `quantity` int(11) NOT NULL,
  `license` varchar(255) NOT NULL,
  `price` double NOT NULL,
  `status` int(11) NOT NULL,
  `coupon` varchar(255) DEFAULT NULL,
  `coupon_amount` float DEFAULT NULL,
  PRIMARY KEY (`id`)
)  ENGINE=MyISAM";
    
    $sql[] = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}mp_payment_methods` (
          `id` int(11) NOT NULL AUTO_INCREMENT,
          `title` varchar(100) NOT NULL,
          `description` text NOT NULL,
          `class_name` varchar(80) NOT NULL,
          `enabled` int(11) NOT NULL,
          `default` int(11) NOT NULL,
          PRIMARY KEY (`id`)
        ) ENGINE=MyISAM";    
    $sql[] = "INSERT INTO `{$wpdb->prefix}mp_payment_methods` (`id`, `title`, `description`, `class_name`, `enabled`, `default`) VALUES(1, 'PayPal', 'PayPal', 'paypal', 1, 1)"; 
    
    /*$sql[] = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}mp_withdraw (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `amount` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `status` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ";  */

$sql[] = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}mp_feature_products` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `productid` int(11) NOT NULL,
  `startdate` int(11) NOT NULL,
  `enddate` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM "; 

$sql[] = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}mp_withdraws` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL DEFAULT '0',
  `date` int(11) NOT NULL DEFAULT '0',
  `amount` double NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM "; 

$sql[] = "ALTER TABLE `{$wpdb->prefix}mp_orders` ADD `order_notes` VARCHAR( 255 ) NULL ,
ADD `payment_method` VARCHAR( 255 ) NULL ,
ADD `shipping_method` VARCHAR( 255 ) NULL ,
ADD `shipping_cost` FLOAT NULL ,
ADD `billing_shipping_data` TEXT NULL ,
ADD `cart_discount` FLOAT NULL  "; 


$sql[] = "ALTER TABLE `{$wpdb->prefix}mp_order_items` ADD `coupon` VARCHAR( 255 ) NULL ,
ADD `coupon_amount` FLOAT NULL   ";   
 
    foreach($sql as $qry){
        $wpdb->query($qry);
    }
    
    // Create Orders Page
    $my_orders = array(
         'post_title' => 'My Orders',
         'post_content' => '[my-orders]',
         'post_status' => 'publish',
         'post_type' => 'page',
         'post_author' => 1    
      );
    wp_insert_post( $my_orders );
  
    update_option('wpmp_access_level','level_10');      
    wpmp_post_types();
    //flush_rules();
}

function wpmp_the_content($content){
    global $post;      
    $settings = get_option('_wpmp_settings');    
    if(!is_single()||!isset($settings['generate_product_page_content'])) return $content;
    if($post->post_type!='wpmarketplace') return $content;     
    @extract(get_post_meta($post->ID,"wpmp_list_opts",true)); 
    include("tpls/product/default.php");
    return $content1;
}

//returns live preview url
function wpmp_live_preview(){
    
}

//returns screen shots url
function wpmp_screen_shots(){
    
}

function wpmp_meta_box_pricing($post){     
    @extract(get_post_meta($post->ID,"wpmp_list_opts",true)); 
    ?>
    <div class="postbox" style="width: 48%;float: right;">
    <h3>Role Based Discount</h3>
     <table width="100%" style="margin: 10px;">
     <tr><th align="left">Role</th><th align="left">Discount (%)</th></tr>
     <tr><td width="250px">Guest (guest) </td><td><input type="text" size="8" name="wpmp_list[discount][guest]" value="<?php echo $discount['guest']; ?>"></td></tr>     
         <?php
    global $wp_roles;
    $roles = array_reverse($wp_roles->role_names);
    foreach( $roles as $role => $name ) { 
    
    
    
    if(  $currentAccess ) $sel = (in_array($role,$currentAccess))?'checked':'';
    
    
    
    ?>
    <tr><td><?php echo $name; ?> (<?php echo $role; ?>) </td><td><input type="text" size="8" name="wpmp_list[discount][<?php echo $role; ?>]" value="<?php echo $discount[$role]; ?>"></td></tr>     
    
    <?php } ?>     
    </table>
    </div>
    <style type="text/css">
    .delet_vdiv{
        float: right; margin: 3px;cursor: pointer;
    }
    .delet_voption{
        cursor: pointer;
    }
    </style>
    <div class="postbox" style="width: 48%;float: left;">
    <h3 id="variation_heading"><?php if($price_variation) echo "Variation Options";else echo "Pricing";?></h3>
         <table   width="100%" style="margin: 10px;" >
     <tr id="base_price" style="<?php //if($price_variation) echo "display: none;"; else echo "";?>"><td width="250px">Price <input type="text" size="16" id="price_label" name="wpmp_list[base_price]"  value="<?php echo $base_price;?>"></td></tr> 
     
     <tr><td><input type="checkbox" <?php if($price_variation) echo "checked='checked'"; else echo "";?> name="wpmp_list[price_variation]" id="price_variation" name="price_variation"> Variation</td></tr>       
    </table>
    
    <div id="price_dis_table" style="<?php if($price_variation) echo ""; else echo "display: none;";?>">
        <div id="vdivs">
        <?php //print_r($variation);
    if($variation){
        //show variations
        
        foreach($variation as $key=>$vname){
            ?>
            <div id="variation_div_<?php echo $key;?>" class="postbox" width="100%" style="margin: 10px; ">
         <img class="delet_vdiv" rel="variation_div_<?php echo $key;?>" title="delete this variation" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt="">
         <table border="0" id="voption_table_<?php echo $key;?>">
         <tr><td colspan="3"><input type="text" name="wpmp_list[variation][<?php echo $key;?>][vname]" id="" placeholder="variation name" value="<?php echo $vname['vname'];?>"></td></tr>
         <?php
    if($vname){
        foreach($vname as $optionkey=>$optionval){
            if($optionkey!="vname"){
?>
         <tr id="voption<?php echo $optionkey;?>"><td><input type="text" name="wpmp_list[variation][<?php echo $key;?>][<?php echo $optionkey;?>][option_name]"  placeholder="option name" value="<?php echo $optionval['option_name'];?>"></td><td><input type="text" name="wpmp_list[variation][<?php echo $key;?>][<?php echo $optionkey;?>][option_price]" id="" placeholder="price" value="<?php echo $optionval['option_price'];?>"></td><td><img class="delet_voption" rel="voption<?php echo $optionkey;?>" title="delete this option" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt=""></td></tr>
         <?php
            }
        }
    }
?>
         </table>
         <div style="clear: both;"></div>
         <input type="button" class="button add_voption" rel="<?php echo $key;?>" value="Add Option">
         </div>
            <?php
        }
    }else{
?>
            <div id="variation_div1" class="postbox" width="100%" style="margin: 10px; ">
         <img class="delet_vdiv" rel="variation_div1" title="delete this variation" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt="">
         <table border="0" id="voption_table_1">
         <tr><td colspan="3"><input type="text" name="wpmp_list[variation][1][vname]" id="" placeholder="variation name"></td></tr>
         <tr id="voption1"><td><input type="text" name="wpmp_list[variation][1][1][option_name]"  placeholder="option name"></td><td><input type="text" name="wpmp_list[variation][1][1][option_price]" id="" placeholder="price"></td><td><img class="delet_voption" rel="voption1" title="delete this option" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt=""></td></tr>
         </table>
         <div style="clear: both;"></div>
         <input type="button" class="button add_voption" rel="1" value="Add Option">
         <!--<tr><th align="left">Label</th><th align="left">Price($)</th></tr>-->
         <!--<tr><td width="250px">Single User/Domain </td><td><input type="text" size="8" name="wpmp_list[price][single_user]" value="<?php echo $price['single_user']; ?>"></td></tr>     
         <tr><td width="250px">Multi User/Domain </td><td><input type="text" size="8" name="wpmp_list[price][multi_user]" value="<?php echo $price['multi_user']; ?>"></td></tr>     
         <tr><td width="250px">Unlimited User/Domain </td><td><input type="text" size="8" name="wpmp_list[price][unlimited_user]" value="<?php echo $price['unlimited_user']; ?>"></td></tr>     
         <tr><td width="250px">Developer </td><td><input type="text" size="8" name="wpmp_list[price][dev_user]" value="<?php echo $price['dev_user']; ?>"></td></tr>-->
         
         </div>
         <?php
    }
?>
         </div>
         <input type="button" class="button" id="add_variation" value="Add Variation">
     </div>
    <script type="text/javascript">
    jQuery('#price_variation').click(function(){
        if(jQuery('#price_variation').attr("checked")){
            //jQuery('#base_price').hide();
            
            jQuery('#variation_heading').text("Variation Options"); 
            jQuery('#price_dis_table').show();
            
        }else{
              //jQuery('#base_price').show();
              jQuery('#variation_heading').text("Pricing"); 
              jQuery('#price_dis_table').hide()  ;
        }
    });
    jQuery('#add_variation').live("click",function (){
        var tm=new Date().getTime();
        jQuery('#vdivs').append('<div id="variation_div_'+tm+'" class="postbox" width="100%" style="margin: 10px; "><img class="delet_vdiv" rel="variation_div_'+tm+'" title="delete this variation" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt=""><table border="0" id="voption_table_'+tm+'"><tr><td colspan="3"><input type="text" name="wpmp_list[variation]['+tm+'][vname]" id="" placeholder="variation name "></td></tr><tr id="voption_'+tm+'"><td><input type="text" name="wpmp_list[variation]['+tm+']['+tm+'][option_name]" id="" placeholder="option name"></td><td><input type="text" name="wpmp_list[variation]['+tm+']['+tm+'][option_price]" id="" placeholder="price"></td><td><img class="delet_voption" rel="voption_'+tm+'" title="delete this option" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt=""></td></tr></table><div style="clear: both;"></div><input type="button" class="button add_voption" rel="'+tm+'" value="Add Option"></div>');
    });
    jQuery('.delet_vdiv').live("click",function(){
        if(confirm("Are you sure to remove"))
            jQuery('#'+jQuery(this).attr("rel")).remove();
    });
    jQuery('.add_voption').live("click",function (){
        var tm=new Date().getTime();
        jQuery('#voption_table_'+jQuery(this).attr("rel")).append('<tr id="voption_'+tm+'"><td><input type="text" name="wpmp_list[variation]['+jQuery(this).attr("rel")+']['+tm+'][option_name]"  placeholder="option name"></td><td><input type="text" name="wpmp_list[variation]['+jQuery(this).attr("rel")+']['+tm+'][option_price]" id="" placeholder="price"></td><td><img class="delet_voption" rel="voption_'+tm+'" title="delete this option" src="<?php echo plugins_url("wpmarketplace");?>/images/remove.png" alt=""></td></tr>');
    });
    
    jQuery('.delet_voption').live("click",function(){
        if(confirm("Are you sure to remove"))
            jQuery('#'+jQuery(this).attr("rel")).remove();
    });
    
   
    </script>
    </div>
    
     
      <div class="postbox" style="width: 48%;float: left;">
    <h3>Coupon Discount</h3>
     <table id="coupon_table"  width="100%" style="margin: 10px;">
     <tr><th align="left">Coupon Code</th><th align="left">Discount(%)</th></tr>
     <?php
    if(count($coupon_code)>0){
        foreach($coupon_code as $coupon_key=>$coupon_val){
        ?>
     <tr><td width="250px"> <input type="text" size="8"  name="wpmp_list[coupon_code][<?php echo $coupon_key?>]"  value="<?php echo $coupon_code[$coupon_key];?>"></td><td><input type="text" size="8" name="wpmp_list[coupon_discount][<?php echo $coupon_key?>]"  value="<?php echo $coupon_discount[$coupon_key];?>"></td></tr> 
          <?php
        }
    }
?>    
     </table>
     
      <table  width="100%" style="margin: 10px;">
      
     <tr><td width="250px">Code <input type="text" size="16" id="coupon_code"  value=""></td><td>Discount <input type="text" size="8" id="coupon_discount"  value=""></td></tr> 
     <tr><td width="250px"></td><td><input class="button" type="button" size="8" id="add_coupon" value="Add"></td></tr>         
    </table>
    <script type="text/javascript">
     
    var cdtm=new Date().getTime();
    jQuery('#add_coupon').live("click",function (){
        var coupon_code=jQuery('#coupon_code').val();
        var coupon_discount= jQuery('#coupon_discount').val();
        jQuery('#coupon_table').append('<tr><td width="250px"> <input size="8" type="text" name="wpmp_list[coupon_code]['+cdtm+']" value="'+coupon_code+'"></td><td><input type="text" size="8" name="wpmp_list[coupon_discount]['+cdtm+']" value="'+coupon_discount+'"></td></tr>');
        jQuery('#coupon_code').val("");
        jQuery('#coupon_discount').val("");
    });
    </script>
        </div>
        
     <div style="clear: both;"></div>
     <?php
}

function wpmp_meta_box_icon(){
    global $post;
     @extract(get_post_meta($post->ID,"wpmp_list_opts",true)); 
    ?>
     
     <?php    
        $path = "wp-content/plugins/wpmarketplace/images/icons/";
        $scan = scandir( '../'.$path );
        $k = 0;
        foreach( $scan as $v )
        {
        if( $v=='.' or $v=='..' or is_dir('../'.$path.$v) ) continue;

        $fileinfo[$k]['file'] = 'wpmarketplace/images/icons/'.$v;
        $fileinfo[$k]['name'] = $v;
        $k++;
        }


        if( !empty($fileinfo) )
        {
                  
         include dirname(__FILE__).'/libs/icon.php';

        } else {

        ?>
        <div class="updated" style="padding: 5px;">
            upload your icons on '/wp-content/plugins/wpmarketplace/images/icons/' using ftp</div>

        <?php } ?>
     
    <?php
}


 

 

register_taxonomy_for_object_type('category', 'wpmarketplace');

function wpmp_meta_boxes(){                                
    $meta_boxes = array(
                            'wpmp-info'=>array('title'=>'Pricing & Discounts','callback'=>'wpmp_meta_box_pricing','position'=>'normal','priority'=>'low'),
                            //'wpmp-demo'=>array('title'=>'Demo Info','callback'=>'wpmp_meta_box_demo','position'=>'normal','priority'=>'low'),
                            //'wpmp-video'=>array('title'=>'Video','callback'=>'wpmp_meta_box_video','position'=>'side','pririty'=>'low'),
                            'wpmp-icons'=>array('title'=>'Icon','callback'=>'wpmp_meta_box_icon','position'=>'side','priority'=>'core')                            
                       );
    $meta_boxes = apply_filters("wpmp_meta_box", $meta_boxes);
    foreach($meta_boxes as $id=>$meta_box){
        extract($meta_box);
        add_meta_box($id, $title, $callback,'wpmarketplace', $position, $priority);
    }    
}

function wpmp_save_meta_data($postid, $post){               
         if($_POST['wpmp_list']){
             /*if(empty($_POST['wpmp_list']['images'])){
                 $_POST['wpmp_list']['images'] = explode(",",$_POST['wpmp_list']['images1']);
             }else{
                 $imageurls = explode(",",$_POST['wpmp_list']['images1']);
                 foreach($imageurls as $vl){
                     array_push($_POST['wpmp_list']['images'], $vl);
                 }
             }*/
             
             //print_r($_POST['wpmp_list']['images']);exit;
             //print_r($_POST['wpmp_list']['images']);
         update_post_meta($postid,"wpmp_list_opts",$_POST['wpmp_list']);  
         foreach($_POST['wpmp_list'] as $k=>$v){
                update_post_meta($postid,$k,$v);
             }
         }
         //print_r($_POST);
         if($_POST['original_post_status']=="draft" && $_POST['post_status']=="publish"){
             global $current_user;
             
             $settings = get_option('_wpmp_settings');
             
             $userinfo=get_userdata($_POST['post_author']);
            $to= $userinfo->user_email; //post author
            $from= $current_user->user_email;
            $subject=$settings['subject_line'];
            $message  = $settings['email_notification'];
            
            $healthy = array("[product_title]", "[product_description]","[username]","[product_url]");
            $yummy   = array($_POST['post_title'], $_POST['post_content'], $userinfo->first_name. " ". $userinfo->last_name,get_permalink( $_POST['post_ID'] ));
            echo $message = str_replace($healthy, $yummy, $message);
            //exit;
            //$message=str_replace()."\r\n" ;
            //$message="The Product you added has been approved. \r\n Product Info : \r\n Title: ".$_POST['post_title']." \r\n Description : ".$_POST['post_content']."\r\n" ;
            $headers = 'From:  <'.$from.'>' . "\r\n";
            wp_mail($to, $subject, $message, $headers );
         }
}

function wpmp_settings(){
        wp_enqueue_script('jquery-ui-core');
        wp_enqueue_script('jquery-ui-accordion');
       include("settings/settings.php");
    
}

function wpmp_orders(){       
    
    $order = new Order();    
    $l = 15;
    
    $p = $_GET['paged']?$_GET['paged']:1;
    $s = ($p-1)*$l;
    if($_GET['task']=='vieworder'){
    $order = $order->getOrder($_GET['id']);
    include('tpls/view-order.php');        
    }
    else {                   
    if($_REQUEST['oid'])    
    $qry[] = "order_id='$_REQUEST[oid]'" ;   
    if($_REQUEST['ost'])    
    $qry[] = "order_status='$_REQUEST[ost]'" ;   
    if($_REQUEST['pst'])
    $qry[] = "payment_status='$_REQUEST[pst]'";    
    if($_REQUEST['sdate']!=''||$_REQUEST['edate']!=''){
        $_REQUEST['edate'] = $_REQUEST['edate']?$_REQUEST['edate']:$_REQUEST['sdate'];
        $_REQUEST['sdate'] = $_REQUEST['sdate']?$_REQUEST['sdate']:$_REQUEST['edate'];
        $sdate = strtotime("$_REQUEST[sdate] 00:00:00");
        $edate = strtotime("$_REQUEST[edate] 23:59:59");
        $qry[] = "(`date` >=$sdate and `date` <=$edate)";
    }
    
    if($qry)
    $qry = "where ".implode(" and ", $qry);
   
    $t = $order->totalOrders($qry); 
    $orders = $order->GetAllOrders($qry,$s, $l);
    include('tpls/orders.php');    
    }
}

function wpmp_myorders($content){
    global $current_user, $_ohtml;
    get_currentuserinfo();
    $order = new Order();         
    $myorders = $order->GetOrders($current_user->ID);
    $_ohtml = '';        
    include('tpls/my-orders.php');
    $content = str_replace('[my-orders]',$_ohtml, $content);
    return $content;
    
}


function wpmp_set_post_type( $query ) {
 
         /*$cat = $query->query_vars['category_name'];
         $set = get_option('_wpmp_settings');
         if ( @in_array($cat, $set['cats']))  */     
        
         if(!is_admin()){
         if(!is_page())
         $query->set( 'post_type', array('post','wpmarketplace'));         
         else
         $query->set( 'post_type', array('post','wpmarketplace','page'));         
         }
         return $query;
         
     } 
     
function wpmp_tabs($attrs,$content){
    
        $tabs = explode("|",$attrs['tabs']);
        $html = "<div class='wpmp-tab-container'><ul class='tabs'>";
        foreach($tabs as $tab){
            ++$tn;
            $html .= "<li><a href='#tab{$tn}'>{$tab}</a></li>\n";
        }
        $html .= "</ul>";
        $html .= '<div class="tab_container">';
        $tab_cons = explode("######",$content);
        foreach($tab_cons as $con){
         ++$tc ;  
        $html .= '<div id="tab'.$tc.'" class="tab_content">'.$con.'</div>';
        }
        $html .= '</div></div>';
        return $html;
    
}
     

function wpmp_menu(){     
    add_submenu_page( 'edit.php?post_type=wpmarketplace', 'Featured Products', 'Featured Products', 'level_2', 'featured', 'wpmp_featured_product');    
    add_submenu_page( 'edit.php?post_type=wpmarketplace', 'Payouts', 'Payouts', 'level_2', 'payouts', 'wpmp_all_payouts');    
    add_submenu_page( 'edit.php?post_type=wpmarketplace', 'Orders &lsaquo; Marketplace', 'Orders', 'level_2', 'orders', 'wpmp_orders');    
    add_submenu_page( 'edit.php?post_type=wpmarketplace', 'Settings &lsaquo; Marketplace', 'Settings', 'level_2', 'settings', 'wpmp_settings');    
}

function wpmp_all_payouts(){
   include_once("libs/payouts.php"); 
}

function wpmp_featured_product(){
    global $wpdb;
    if($_POST['task']=="add_feature"){
        //print_r($_POST);
        foreach($_POST['fids'] as $fpid){
            $wpdb->insert( 
                "{$wpdb->prefix}mp_feature_products", 
                array( 
                    'productid' => $fpid, 
                    'startdate' => strtotime($_POST['sdate']) ,
                    'enddate' => strtotime($_POST['edate']) 
                ), 
                array( 
                    '%d', 
                    '%d', 
                    '%d' 
                ) 
            );
        }
    }
    wp_enqueue_script('jquery-ui-core');
    wp_enqueue_script('jquery-ui-datepicker');
    
    $featured_products=$wpdb->get_results("select * from {$wpdb->prefix}mp_feature_products fp inner join {$wpdb->prefix}posts p on p.ID=fp.productid where p.post_type='wpmarketplace' ");
    include_once('tpls/feature_list.php'); 
}

function wpmp_save_settings(){
    update_option('_wpmp_settings',$_POST['_wpmp_settings']);    
    die('Settings Saved Successfully');
}

function wpmp_download(){    
    if(!$_GET['wpmpfile']) return;
    global $wpdb, $current_user;
    get_currentuserinfo();
    $order = new Order();
    $odata = $order->GetOrder($_GET['oid']);
    $items = unserialize($odata->items);    
    $meta = get_post_meta($_GET['wpmpfile'],"wpmp_list_opts",true);
    
    @extract($meta);   
    if(array_sum($price)==0&&(int)$_GET['wpmpfile']>0){
        $fname = dirname(__FILE__).'/product-files/'.$file;      
        include("libs/process.php");
    }
    if(@in_array($_GET['wpmpfile'],$items)&&$_GET['oid']!=''&&is_user_logged_in()&&$current_user->ID==$odata->uid){        
        @extract(get_post_meta($_GET['wpmpfile'],"wpmp_list_opts",true));   
        $fname = dirname(__FILE__).'/product-files/'.$file;      
        include("libs/process.php");
    }
}

 
function wpmp_do_login(){
     if($_REQUEST['checkout_login']=="login"){
        global $wp_query, $post, $sap;      
        if(!$_POST['login']) return;
        unset($_SESSION['login_error']);
        the_post();
        $creds = array();
        $creds['user_login'] = $_POST['login']['log'];
        $creds['user_password'] = $_POST['login']['pwd'];
        $creds['remember'] = $_POST['rememberme'];
        $user = wp_signon( $creds, false );
        if ( is_wp_error($user) ){                
           $_SESSION['login_error'] = $user->get_error_message();
           //header("location: ".$_POST['permalink'].$sap.'task=login');
           die("failed");
        } else {
           //header("location: ".$_POST['permalink']); 
           echo 'success';
           die();
        }
     }
}

function wpmp_do_register(){
    if($_REQUEST['checkout_register']=="register"){
    global $wp_query, $sap;
    if(!$_POST['reg']) return;
    extract($_POST['reg']);
    $_SESSION['tmp_reg_info'] = $_POST['reg'];    
    $user_id = username_exists( $user_login );
    if($user_login==''){
        $_SESSION['reg_error'] =  __('Username is Empty!');        
        header("location: ".$_POST['permalink'].$sap.'task=register');
        die();
    }
    if($user_email==''||!is_email($user_email)){
        $_SESSION['reg_error'] =  __('Invalid Email Address!');        
        header("location: ".$_POST['permalink'].'register/');
        die();
    }
    if ( !$user_id ) {
        $user_id = email_exists( $user_email );
        if ( !$user_id ) {
        //$random_password = wp_generate_password( 12, false );
        $user_id = wp_create_user( $user_login, $user_pass, $user_email );
        
        $headers = "From: WP Eden <no-reply@wpeden.com>\r\nContent-type: text/html";
        $message = "Hello $user_login,<br/>\r\nThanks for registering to wpeden.com<br/>Here is your login info:<br/>\r\nUsername: $user_login<br/>\r\nPassword: $user_pass<br/>\r\n<br/>\r\nThanks<br/><b>WP Eden</b>";
        
        if($user_id){
            wp_mail($user_email,"Welcome to wpeden.com",$message,$headers);
            unset($_SESSION['tmp_reg_info']);
            unset($_SESSION['login_error']);
            $creds = array();
            $creds['user_login'] = $user_login;
            $creds['user_password'] = $user_pass;
            $creds['remember'] = "forever";
            $user = wp_signon( $creds, false );
            if ( is_wp_error($user) ){                
               $_SESSION['login_error'] = $user->get_error_message();
               //header("location: ".$_POST['permalink'].$sap.'task=login');
               die("failed");
            } else {
               //header("location: ".$_POST['permalink']); 
               die("success");
            }
         
        }
        //header("location: ".$_POST['permalink'].$sap.'task=login'); 
        die();
        } else {
            $_SESSION['reg_error'] =  __('Email already exists.');        
            header("location: ".$_POST['permalink'].$sap.'task=register');
            die();
        }
    } else {
        $_SESSION['reg_error'] =  __('User already exists.');        
        header("location: ".$_POST['permalink'].$sap.'task=register');
        die();
    }
    
    }
}

function wpmp_save_billing_info(){
    if($_REQUEST['checkout_billing']=="save"){
        global $current_user;
        get_currentuserinfo();
        $order = new Order();
        if($_SESSION['orderid']){
            $data=array(
                'billing_shipping_data'=>serialize($_POST['checkout'])        
            ); 
           $insertid=$order->Update($data, $_SESSION['orderid']);
        }else{
            $cart_data = wpmp_get_cart_data();
            //print_r($cart_data);
            $insertid=$order->NewOrder(uniqid(), "", "", 0,$current_user->ID,'Processing','Processing','',"","","",0.0,serialize($_POST['checkout']));
            //print_r($_POST);
            session_register("orderid");
            $_SESSION['orderid']=$insertid;
        }
        update_user_meta($current_user->ID, 'user_billing_shipping', serialize($_POST['checkout']));
        //echo serialize($_POST['checkout']);
        //if($insertid)echo "success";else echo "failed";
        echo "success";
        die();
    }
}

function wpmp_save_shipping_info(){
    if($_REQUEST['checkout_shipping']=="save"){
        global $current_user;
        get_currentuserinfo();
        $data=array(
        'shipping_method'=>$_POST['shipping_method'],
        'shipping_cost'=>$_POST['shipping_rate']
        );
        $order = new Order();
        $od=$order->Update($data, $_SESSION['orderid']);
       //if($od)echo "success";else echo "failed";
       //echo $_SESSION['orderid'];
       echo "success";
        //echo $_SESSION['orderid']." ".$_POST['shipping_method'];
        //if($insertid)echo "success";else echo "failed";
        die();
    }
}

function wpmp_save_payment_method_info(){
    if($_REQUEST['checkout_payment']=="save"){
        global $current_user;
        get_currentuserinfo();
        $data=array(
        'payment_method'=>$_POST['payment_method']        
        );
        $order = new Order();
        $od=$order->Update($data, $_SESSION['orderid']);
        $order_info=$order->GetOrder($_SESSION['orderid']);
        //if($od)echo "success";else echo "failed";
        //print_r($order_info);
        $orderi['shipping_method']=$order_info->shipping_method;
        $orderi['shipping_rate']=$order_info->shipping_cost;
        $orderi['success']="success";     
        echo json_encode($orderi);
        //echo "success";
        //echo $_SESSION['orderid']." ".$_POST['shipping_method'];
        //if($insertid)echo "success";else echo "failed";
        die();
    }
}



function wpmp_place_order(){
    if($_REQUEST['wpmpaction']=='placeorder'){
        //save 
        $data=array(
        'items'=>serialize($_POST['cart_items']),
        'cart_data'=>serialize($_POST['cart_items']),
        'total'=>$_POST['order_total'],
        'order_notes'=>$_POST['order_comments'],
        'cart_discount' => $_POST['cart_discount']
        );
        $order = new Order();
        $od=$order->Update($data, $_SESSION['orderid']);
        //update order items
        $order->UpdateOrderItems(serialize($_POST['cart_items']), $_SESSION['orderid']);
        //PayNow();
        $payment = new Payment();
        $payment->InitiateProcessor($_POST['payment_system']);
        $payment->Processor->OrderTitle = 'WPMP Order# '.$_SESSION['orderid'];
        $payment->Processor->InvoiceNo = $_SESSION['orderid'];
        $payment->Processor->Custom = $_SESSION['orderid'];
        $payment->Processor->Amount = number_format($_POST['order_total'],2);
        /*$payment->Processor->Ship_amount = number_format($_POST['ship_amount'],2);
        $payment->Processor->Ship_method = $_POST['ship_method'];*/
        echo $payment->Processor->ShowPaymentForm(1);
        //print_r($_POST);
        wpmp_empty_cart(); 
        die();
    }
}

function wpmp_paypal_notification(){
    if($_REQUEST['action']=="paypal_notification"){
        //print_r($_POST);
        if(isset($_POST["txn_id"]) && isset($_POST["txn_type"])){
            global $wpdb;
            $wpdb->update( 
                "{$wpdb->prefix}mp_orders", 
                array(
                   'payment_status' => "completed"
                ), 
                array('order_id'=>$_POST['custom']),
                array(
                    '%s'
                ),
                array( '%d' )  
            );
        }
    }
}


function wpmp_withdraw_paypal_notification(){
    if($_REQUEST['action']=="withdraw_paypal_notification"){
        //print_r($_POST);
        if(isset($_POST["txn_id"]) && isset($_POST["txn_type"])&& $_POST["status"]=="Completed"){
            global $wpdb;
            $wpdb->update( 
                "{$wpdb->prefix}mp_withdraws", 
                array(
                   'status' => 1
                ), 
                array('id'=>$_POST['custom']),
                array(
                    '%d'
                ),
                array( '%d' )  
            );
        }
    }
}

function wpmp_ajax_payfront(){
    if($_POST['task']=="paymentfront" && $_POST['action']=="wpmp_ajax_call"){
        $data['order_id']=$_POST['order_id'];
        $data['payment_method']=$_POST['payment_method'];
        
        PayNow($data);
        die();
    }
}

function wpmp_ajax_call(){
    if(function_exists($_POST['execute'])){
        echo call_user_func($_POST['execute']);
        die();
    }
}
//function for adding product using shortcode
function wpmp_front_add_product(){
     include("libs/scode_add-product.php");
}
//function for earnings using shortcode
function wpmp_earnings(){
     include("libs/scode_earnings.php");
}



function plu_admin_enqueue() {
    /*if(!($condition_to_check_your_page))// adjust this if-condition according to your theme/plugin
       return;*/
    wp_enqueue_script('plupload-all');
 
    /*wp_register_script('myplupload', '/js/admin/myplupload.js', array('jquery'));
    wp_enqueue_script('myplupload');
 
    wp_register_style('myplupload', '/css/admin/myplupload.css');
    wp_enqueue_style('myplupload');*/
}
add_action( 'admin_enqueue_scripts', 'plu_admin_enqueue' );


function plupload_admin_head() {
// place js config array for plupload
    $plupload_init = array(
        'runtimes' => 'html5,silverlight,flash,html4',
        'browse_button' => 'plupload-browse-button', // will be adjusted per uploader
        'container' => 'plupload-upload-ui', // will be adjusted per uploader
        'drop_element' => 'drag-drop-area', // will be adjusted per uploader
        'file_data_name' => 'async-upload', // will be adjusted per uploader
        'multiple_queues' => true,
        'max_file_size' => wp_max_upload_size() . 'b',
        'url' => admin_url('admin-ajax.php'),
        'flash_swf_url' => includes_url('js/plupload/plupload.flash.swf'),
        'silverlight_xap_url' => includes_url('js/plupload/plupload.silverlight.xap'),
        'filters' => array(array('title' => __('Allowed Files'), 'extensions' => '*')),
        'multipart' => true,
        'urlstream_upload' => true,
        'multi_selection' => false, // will be added per uploader
         // additional post data to send to our ajax hook
        'multipart_params' => array(
            '_ajax_nonce' => "", // will be added per uploader
            'action' => 'plupload_action', // the ajax action name
            'imgid' => 0 // will be added per uploader
        )
    );
?>
<script type="text/javascript">
    var base_plupload_config=<?php echo json_encode($plupload_init); ?>;
    var pluginurl = "<?php echo plugins_url("wpmarketplace/"); ?>";
</script>
<?php
}
add_action("admin_head", "plupload_admin_head");


function g_plupload_action() {
 
    // check ajax noonce
    $imgid = $_POST["imgid"];
    check_ajax_referer($imgid . 'pluploadan');
 
    // handle file upload
    $status = wp_handle_upload($_FILES[$imgid . 'async-upload'], array('test_form' => true, 'action' => 'plupload_action'));
 
    // send the uploaded file url in response
    echo $status['url'];
    exit;
}
add_action('wp_ajax_plupload_action', "g_plupload_action");

function wpmp_move_upload_previewfile(){
    $adpdir = WP_PLUGIN_DIR.'/wpmarketplace/previews/';
    //echo ($_POST['fileurl']);
    $uploads = wp_upload_dir();
    $tempFile=$uploads['basedir'].str_replace("uploads","",strstr($_POST['fileurl'],"uploads"));
    $filename=basename($_POST['fileurl']);
    $fname="wpmp-adp-". time().'-'.$filename;
    $targetFile =  $adpdir.$fname;
    rename($tempFile, $targetFile);
    die($fname);
}

function wpmp_move_upload_productfile(){
    $adpdir = WP_PLUGIN_DIR.'/wpmarketplace/product-files/';
    //echo ($_POST['fileurl']);
    $uploads = wp_upload_dir();
    $tempFile=$uploads['basedir'].str_replace("uploads","",strstr($_POST['fileurl'],"uploads"));
    $filename=basename($_POST['fileurl']);
    $fname="wpmp-p-". time().'-'.$filename;
    $targetFile =  $adpdir.$fname;
    rename($tempFile, $targetFile);
    die($fname);
}

function wpmp_move_upload_featuredfile(){
    
    die($_POST['fileurl']);
}

    //auto sugession function
function wpmp_autosuggest(){
    //echo "in this function";
   if($_REQUEST['tag']){
       global $wpdb;
      $featured_products=$wpdb->get_results("select * from  {$wpdb->prefix}posts p  where p.post_type='wpmarketplace' and p.post_title like '%{$_REQUEST['tag']}%' ");
      
      $rtn="[";
      foreach($featured_products as $value){
           $fp[] = array('key'=>$value->ID, 'value'=>$value->post_title);
      }
      
      echo json_encode($fp);
      die(); 
   } 
}

function wpmp_remove_featured(){
    if($_POST['id']){
        global $wpdb;
        $wpdb->query("delete from {$wpdb->prefix}mp_feature_products where id='{$_POST['id']}'");
        die();
    }
}

if(is_admin()){    
    add_action("admin_menu","wpmp_menu");            
    add_action( 'admin_init', 'wpmp_meta_boxes', 0 );
    add_action( 'save_post', 'wpmp_save_meta_data',10,2);
    add_action( 'wp_ajax_wpmp_save_settings', 'wpmp_save_settings'); 
    add_action( 'wp_ajax_wpmp_ajax_call', 'wpmp_ajax_call'); 
    add_action( 'wp_ajax_moveuploadprevfile', 'wpmp_move_upload_previewfile');
    add_action( 'wp_ajax_moveuploadprofile', 'wpmp_move_upload_productfile');
    add_action( 'wp_ajax_moveuploadfeaturedfile', 'wpmp_move_upload_featuredfile');
    //for auto suggesting
    add_action( 'wp_ajax_wpmp_autosuggest', 'wpmp_autosuggest');
    //for removing feature product
    add_action( 'wp_ajax_wpmp_remove_featured', 'wpmp_remove_featured');
    //wp_enqueue_script('jquery-form');      
}
 

wp_enqueue_script('jquery');
wp_enqueue_script('jquery-form');

$wpmp_plugin->load_styles();
$wpmp_plugin->load_scripts();

add_theme_support('post-thumbnails');
register_activation_hook(__FILE__,'wpmp_install');
$wpmp_plugin->load_modules();  



